<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupPrice extends AbstractStructArrayBase
{
    /**
     * The FareGroupPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupPrice[]
     */
    public $FareGroupPrice;
    /**
     * Constructor method for ArrayOfJP_FareGroupPrice
     * @uses ArrayOfJP_FareGroupPrice::setFareGroupPrice()
     * @param \StructType\JP_FareGroupPrice[] $fareGroupPrice
     */
    public function __construct(array $fareGroupPrice = array())
    {
        $this
            ->setFareGroupPrice($fareGroupPrice);
    }
    /**
     * Get FareGroupPrice value
     * @return \StructType\JP_FareGroupPrice[]|null
     */
    public function getFareGroupPrice()
    {
        return $this->FareGroupPrice;
    }
    /**
     * Set FareGroupPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPrice[] $fareGroupPrice
     * @return \ArrayType\ArrayOfJP_FareGroupPrice
     */
    public function setFareGroupPrice(array $fareGroupPrice = array())
    {
        foreach ($fareGroupPrice as $arrayOfJP_FareGroupPriceFareGroupPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupPriceFareGroupPriceItem instanceof \StructType\JP_FareGroupPrice) {
                throw new \InvalidArgumentException(sprintf('The FareGroupPrice property can only contain items of \StructType\JP_FareGroupPrice, "%s" given', is_object($arrayOfJP_FareGroupPriceFareGroupPriceItem) ? get_class($arrayOfJP_FareGroupPriceFareGroupPriceItem) : gettype($arrayOfJP_FareGroupPriceFareGroupPriceItem)), __LINE__);
            }
        }
        $this->FareGroupPrice = $fareGroupPrice;
        return $this;
    }
    /**
     * Add item to FareGroupPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPrice $item
     * @return \ArrayType\ArrayOfJP_FareGroupPrice
     */
    public function addToFareGroupPrice(\StructType\JP_FareGroupPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupPrice) {
            throw new \InvalidArgumentException(sprintf('The FareGroupPrice property can only contain items of \StructType\JP_FareGroupPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FareGroupPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupPrice
     */
    public function getAttributeName()
    {
        return 'FareGroupPrice';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FareGroupPrice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
